package 
{
	import com.divillysausages.ds.DS;
	import com.divillysausages.escvel.constants.Style;
	import com.divillysausages.escvel.state.Game;
	import flash.display.Sprite;
	import flash.events.Event;
	
	/**
	 * The Main class, which controls the game
	 * @author Damian Connolly
	 */
	public class Main extends Sprite 
	{
		
		/*******************************************************************************************/
		
		/**
		 * Creates the Main class. If the stage is available, we call _init()
		 * otherwise we wait until we're added
		 */
		public function Main():void 
		{
			if ( this.stage ) this._init();
			else this.addEventListener( Event.ADDED_TO_STAGE, this._init );
		}
		
		/*******************************************************************************************/
		
		// called when the stage is available; inits the game
		private function _init( e:Event = null ):void 
		{
			// remove our stage listener
			this.removeEventListener( Event.ADDED_TO_STAGE, this._init );
			
			// start the engine
			DS.start( this );
			DS.bgColour = Style.BG_COLOUR;
			
			// get started
			Game.instance.changeState( Game.STATE_INIT );
		}
		
	}
	
}