package 
{
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.ProgressEvent;
	import flash.utils.getDefinitionByName;
	
	/**
	 * The Preloader loads the game and creates the Main class when we're ready
	 * @author Damian Connolly
	 */
	public class Preloader extends MovieClip 
	{
		
		/**
		 * Creates our preloader; adds listeners to see if we're loaded yet
		 */
		public function Preloader() 
		{
			this.addEventListener( Event.ENTER_FRAME, this._checkFrame );
			this.loaderInfo.addEventListener( ProgressEvent.PROGRESS, this._onProgress );
			// show loader
		}
		
		/*******************************************************************************************/
		
		// called as our loading progresses. update the preloader
		private function _onProgress( e:ProgressEvent ):void 
		{
			// update loader
		}
		
		// checks every frame to see if we're fully loaded yet
		private function _checkFrame( e:Event ):void 
		{
			if ( this.currentFrame == this.totalFrames ) 
			{
				this.removeEventListener( Event.ENTER_FRAME, this._checkFrame );
				this._startup();
			}
		}
		
		// searches for the Main class, creates it, and adds it to the stage
		private function _startup():void 
		{
			// hide loader
			this.stop();
			this.loaderInfo.removeEventListener(ProgressEvent.PROGRESS, this._onProgress );
			var mainClass:Class = getDefinitionByName("Main") as Class;
			this.stage.addChild( new mainClass() as DisplayObject );
			this.stage.removeChild( this );
		}
		
	}
	
}