package com.divillysausages.escvel.assets
{
	import com.divillysausages.ds.asset.EmbeddedAssets;
	
	/**
	 * The resources that we'll use in the game
	 * @author Damian Connolly
	 */
	public class Resources extends EmbeddedAssets 
	{
		
		/*******************************************************************************************/
		
		/**
		 * The game font
		 */
		public static const GAME_FONT:String = "gameFont";
		
		/**
		 * The ds logo image
		 */
		public static const DS_IMAGE:String = "../../../../../assets/ds_logo.png";
		
		/**
		 * The ds sound
		 */
		public static const DS_SOUND:String = "../../../../../assets/ds.mp3";
		
		/**
		 * The buy sound
		 */
		public static const BUY_SOUND:String = "../../../../../assets/buy.mp3";
		
		/**
		 * The sell sound
		 */
		public static const SELL_SOUND:String = "../../../../../assets/sell.mp3";
		
		/**
		 * The pickup perfect sound
		 */
		public static const PICKUP_PERFECT_SOUND:String = "../../../../../assets/pickup_perfect.mp3";
		
		/**
		 * The hit sound
		 */
		public static const HIT_SOUND:String = "../../../../../assets/hit.mp3";
		
		/**
		 * The good deal sound
		 */
		public static const GOOD_DEAL_SOUND:String = "../../../../../assets/good_deal.mp3";
		
		/**
		 * The bad deal sound
		 */
		public static const BAD_DEAL_SOUND:String = "../../../../../assets/bad_deal.mp3";
		
		/**
		 * The music
		 */
		public static const MUSIC:String = "../../../../../assets/music.mp3";
		
		/**
		 * The rainbow image
		 */
		public static const RAINBOW_IMAGE:String = "../../../../../assets/rainbow.png";
		
		/**
		 * The player shield image
		 */
		public static const PLAYER_SHIELD_IMAGE:String = "../../../../../assets/player_shield.png";
		
		/**
		 * The pirate shield image
		 */
		public static const PIRATE_SHIELD_IMAGE:String = "../../../../../assets/pirate_shield.png";
		
		/**
		 * The mouse image
		 */
		public static const MOUSE_IMAGE:String = "../../../../../assets/mouse.png";
		
		/**
		 * The player image
		 */
		public static const PLAYER_IMAGE:String = "../../../../../assets/player.png";
		
		/**
		 * The pirate image
		 */
		public static const PIRATE_IMAGE:String = "../../../../../assets/pirate.png";
		
		/**
		 * The planet image
		 */
		public static const PLANET_IMAGE:String = "../../../../../assets/planet.png";
		
		/**
		 * The stars image
		 */
		public static const STARS_IMAGE:String = "../../../../../assets/stars.png";
		
		/*******************************************************************************************/
		
		// the game font
		[Embed(systemFont="PF Ronda Seven", fontName="gameFont", mimeType = "application/x-font", fontWeight="normal", fontStyle="normal", unicodeRange="englishRange", advancedAntiAliasing="true", embedAsCFF="false")]
		private var m_font:Class;
		
		// the ds logo image
		[Embed(source = "../../../../../assets/ds_logo.png")]
		public var dsImage:Class;
		
		// the ds sound
		[Embed(source = "../../../../../assets/ds.mp3", mimeType = "audio/mpeg")]
		public var dsSound:Class;
		
		// the buy sound
		[Embed(source = "../../../../../assets/buy.mp3", mimeType = "audio/mpeg")]
		public var buySound:Class;
		
		// the sell sound
		[Embed(source = "../../../../../assets/sell.mp3", mimeType = "audio/mpeg")]
		public var sellSound:Class;
		
		// the pickup perfect sound
		[Embed(source = "../../../../../assets/pickup_perfect.mp3", mimeType = "audio/mpeg")]
		public var pickUpPerfectSound:Class;
		
		// the hit sound
		[Embed(source = "../../../../../assets/hit.mp3", mimeType = "audio/mpeg")]
		public var hitSound:Class;
		
		// the good deal sound
		[Embed(source = "../../../../../assets/good_deal.mp3", mimeType = "audio/mpeg")]
		public var goodDealSound:Class;
		
		// the bad deal sound
		[Embed(source = "../../../../../assets/bad_deal.mp3", mimeType = "audio/mpeg")]
		public var badDealSound:Class;
		
		// the music sound
		[Embed(source = "../../../../../assets/music.mp3", mimeType = "audio/mpeg")]
		public var musicSound:Class;
		
		// the rainbow trail
		[Embed(source = "../../../../../assets/rainbow.png")]
		public var rainbowImage:Class;
		
		// the player shield
		[Embed(source = "../../../../../assets/player_shield.png")]
		public var playerShieldImage:Class;
		
		// the pirate shield
		[Embed(source = "../../../../../assets/pirate_shield.png")]
		public var pirateShieldImage:Class;
		
		// the mouse image
		[Embed(source = "../../../../../assets/mouse.png")]
		public var mouseImage:Class;
		
		// the player image
		[Embed(source = "../../../../../assets/player.png")]
		public var playerImage:Class;
		
		// the pirate image
		[Embed(source = "../../../../../assets/pirate.png")]
		public var pirateImage:Class;
		
		// the planet image
		[Embed(source = "../../../../../assets/planet.png")]
		public var planetImage:Class;
		
		// the stars image
		[Embed(source = "../../../../../assets/stars.png")]
		public var starsImage:Class;
		
	}

}