package com.divillysausages.escvel.constants 
{
	import com.divillysausages.ds.util.Enum;
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class Trade extends Enum
	{
		{ initEnum( Trade ); }
		
		public static const ORGANIC_BANANAS:Trade = new Trade;
		public static const SPACE_CATS:Trade = new Trade;
		public static const REDHEADS:Trade = new Trade;
		public static const EYEBALLS:Trade = new Trade;
		public static const GOLD:Trade = new Trade;
		public static const RAINBOWS:Trade = new Trade;
		public static const BRUSHES:Trade = new Trade;
		public static const SWEETS:Trade = new Trade;
		public static const TIGERS:Trade = new Trade;
		public static const GHOSTS:Trade = new Trade;
		
		public static function toString( trade:Trade = null ):String
		{
			switch( trade )
			{
				case Trade.ORGANIC_BANANAS:
					return "Organic Bananas";
				case Trade.SPACE_CATS:
					return "Space Cats";
				case Trade.REDHEADS:
					return "Redheads";
				case Trade.EYEBALLS:
					return "Eyeballs";
				case Trade.GOLD:
					return "Gold";
				case Trade.RAINBOWS:
					return "Rainbows";
				case Trade.BRUSHES:
					return "Brushes";
				case Trade.SWEETS:
					return "Sweets";
				case Trade.TIGERS:
					return "Tigers";
				case Trade.GHOSTS:
					return "Ghosts";
			}
			return "Magic sauce";
		}
		
		public static function toButtonString( trade:Trade ):String
		{
			switch( trade )
			{
				case Trade.ORGANIC_BANANAS:
					return "Organic\nBananas";
				case Trade.SPACE_CATS:
					return "Space\nCats";
				case Trade.REDHEADS:
					return "Redheads";
				case Trade.EYEBALLS:
					return "Eyeballs";
				case Trade.GOLD:
					return "Gold";
				case Trade.RAINBOWS:
					return "Rainbows";
				case Trade.BRUSHES:
					return "Brushes";
				case Trade.SWEETS:
					return "Sweets";
				case Trade.TIGERS:
					return "Tigers";
				case Trade.GHOSTS:
					return "Ghosts";
			}
			return "Magic sauce";
		}
		
		public static function getBasePrice( trade:Trade ):int
		{
			switch( trade )
			{
				case Trade.ORGANIC_BANANAS:
					return 400;
				case Trade.SPACE_CATS:
					return 250;
				case Trade.REDHEADS:
					return 200;
				case Trade.EYEBALLS:
					return 100;
				case Trade.GOLD:
					return 800;
				case Trade.RAINBOWS:
					return 850;
				case Trade.BRUSHES:
					return 150;
				case Trade.SWEETS:
					return 300;
				case Trade.TIGERS:
					return 600;
				case Trade.GHOSTS:
					return 500;
			}
			return 0;
		}
		
		public static function getColour( trade:Trade ):uint
		{
			switch( trade )
			{
				case Trade.ORGANIC_BANANAS:
					return 0xdce14a;
				case Trade.SPACE_CATS:
					return 0xec911a;
				case Trade.REDHEADS:
					return 0xcd2f0f;
				case Trade.EYEBALLS:
					return 0xede8e6;
				case Trade.GOLD:
					return 0xfbe135;
				case Trade.RAINBOWS:
					return 0xd513aa;
				case Trade.BRUSHES:
					return 0x74868f;
				case Trade.SWEETS:
					return 0x08c33d;
				case Trade.TIGERS:
					return 0xff7e00;
				case Trade.GHOSTS:
					return 0xb2aaa2;
			}
			return 0;
		}
		
		public static function getRandom( ignore1:Trade = null, ignore2:Trade = null, ignore3:Trade = null ):Trade
		{
			var max:int 	= Enum.getEnum( Trade ).length;
			var trade:Trade	= null;
			while ( trade == null )
			{
				var ran:int = int( Math.random() * max );
				var t:Trade	= Enum.getByIndex( Trade, ran ) as Trade;
				if ( t == ignore1 || t == ignore2 || t == ignore3 )
					continue;
				else
					trade = t;
			}
			return trade;
		}
		
	}

}