package com.divillysausages.escvel.gui 
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import org.osflash.signals.Signal;
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class Button extends Sprite
	{
		public var onClick:Signal = new Signal( Button );
		
		protected var m_lineColour:uint = 0x666666;
		protected var m_alphas:Array	= [1.0, 1.0];
		protected var m_ratios:Array	= [0, 255];
		protected var m_matrix:Matrix	= null;
		
		private var m_normalColours:Array 	= [0xe6e6e6, 0xc0c0c0];
		private var m_hoveredColours:Array	= [0xe3e685, 0xbec06f];
		private var m_pressedColours:Array	= [0xcc8120, 0xaa6c1a];
		
		private var m_enabled:Boolean	= true;
		private var m_hovered:Boolean	= false;
		private var m_pressed:Boolean	= false;
		private var m_width:Number		= 45.0;
		private var m_height:Number		= 45.0;
		
		override public function get width():Number { return this.m_width; }
		override public function set width( n:Number ):void
		{
			this.m_width = n;
			this.m_matrix.createGradientBox( this.m_width, this.m_height, Math.PI * 0.5 );
			this.draw();
		}
		
		override public function get height():Number { return this.m_height; }
		override public function set height( n:Number ):void
		{
			this.m_height = n;
			this.m_matrix.createGradientBox( this.m_width, this.m_height, Math.PI * 0.5 );
			this.draw();
		}
		
		public function get colours():Array 
		{
			return ( this.m_pressed ) ? this.m_pressedColours :
						( this.m_hovered ) ? this.m_hoveredColours :
							this.m_normalColours;
		}
		
		public function get enabled():Boolean { return this.m_enabled; }
		public function set enabled( b:Boolean ):void
		{
			this.m_enabled = b;
			if ( this.m_enabled )
			{
				this.addEventListener( MouseEvent.MOUSE_OVER, this._onOver );
				this.addEventListener( MouseEvent.MOUSE_OUT, this._onOut );
				this.addEventListener( MouseEvent.MOUSE_DOWN, this._onDown );
				this.addEventListener( MouseEvent.MOUSE_UP, this._onUp );
				this.addEventListener( MouseEvent.CLICK, this._onClick );
				this.alpha = 1.0;
			}
			else
			{
				this.removeEventListener( MouseEvent.MOUSE_OVER, this._onOver );
				this.removeEventListener( MouseEvent.MOUSE_OUT, this._onOut );
				this.removeEventListener( MouseEvent.MOUSE_DOWN, this._onDown );
				this.removeEventListener( MouseEvent.MOUSE_UP, this._onUp );
				this.removeEventListener( MouseEvent.CLICK, this._onClick );
				this.alpha = 0.5;
			}
		}
		
		public function Button() 
		{
			this.m_matrix = new Matrix;
			this.m_matrix.createGradientBox( this.m_width, this.m_height, Math.PI * 0.5 );
			
			// enabled to start
			this.enabled = true;
			
			// draw our button
			this.draw();
		}
		
		public function draw():void
		{
			this.graphics.clear();
			this.graphics.lineStyle( 1.5, this.m_lineColour );
			this.graphics.beginGradientFill( "linear", this.colours, this.m_alphas, this.m_ratios, this.m_matrix );
			this.graphics.drawRoundRect( 0.0, 0.0, this.m_width, this.m_height, 10.0, 10.0 );
			this.graphics.endFill();
		}
		
		private function _onOver( e:MouseEvent ):void
		{
			this.m_hovered = true;
			this.draw();
		}
		
		private function _onOut( e:MouseEvent ):void
		{
			this.m_pressed	= false;
			this.m_hovered 	= false;
			this.draw();
		}
		
		private function _onDown( e:MouseEvent ):void
		{
			this.m_pressed = true;
			this.draw();
		}
		
		private function _onUp( e:MouseEvent ):void
		{
			this.m_pressed = false;
			this.draw();
		}
		
		private function _onClick( e:MouseEvent ):void
		{
			this.onClick.dispatch( this );
		}
		
	}

}