package com.divillysausages.escvel.gui
{
	import com.divillysausages.ds.collections.objectpool.IPoolObj;
	import com.divillysausages.ds.DS;
	import com.divillysausages.escvel.assets.Resources;
	import com.divillysausages.escvel.constants.Mood;
	import com.divillysausages.escvel.logic.ObjectPools;
	import com.greensock.TweenLite;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class Feedback extends TextField implements IPoolObj
	{
		private static const TF:TextFormat = new TextFormat(Resources.GAME_FONT, 11.0);
		
		public function Feedback()
		{
			this.defaultTextFormat 	= Feedback.TF;
			this.autoSize			= TextFieldAutoSize.LEFT;
			this.selectable			= false;
			this.mouseEnabled		= false;
			this.mouseWheelEnabled	= false;
			this.embedFonts			= true;
		}
		
		/* INTERFACE com.divillysausages.ds.collections.objectpool.IPoolObj */
		
		public function setMessage( msg:String, mood:Mood, x:Number, y:Number, center:Boolean = false ):void
		{
			this.textColor 	= Mood.getColour( mood );
			this.text		= msg;
			this.x			= x;
			this.y			= y;
			
			if ( center )
				this.x -= this.width * 0.5;
		}
		
		public function init(params:* = null):void
		{
			DS.stage.addChild( this );
			TweenLite.to( this, 2.0, { y:"-40.0", alpha:0.0, onComplete:ObjectPools.returnFeedback, onCompleteParams:[this] } );
		}
		
		public function reset():void
		{
			this.alpha = 1.0;
			DS.stage.removeChild( this );
		}
		
		public function destroy():void
		{
			if ( this.parent != null )
				this.parent.removeChild( this )
		}
	
	}

}