package com.divillysausages.escvel.gui  
{
	import com.divillysausages.ds.particles.Emitter;
	import com.divillysausages.ds.particles.PointParticle;
	import flash.display.BitmapData;
	
	/**
	 * The pickup emitter
	 * @author Damian
	 */
	public class PickUpEmitter
	{
		
		/*******************************************************************************************/
		
		private var m_emitter:Emitter 					= null;
		private var m_emitterRenderer:ParticleRenderer	= null;	// a reference to emitter renderer object
		
		/*******************************************************************************************/
		
		public function PickUpEmitter( renderer:ParticleRenderer )
		{
			this.m_emitterRenderer = renderer;
			
			// create an emitter for our blood
			var bmd:Vector.<BitmapData> = Vector.<BitmapData>( [
				new BitmapData( 2, 2, true, 0xff1800ff ),
				new BitmapData( 2, 2, true, 0xc88726ff ),
				new BitmapData( 2, 2, true, 0x96d75dff ),
				new BitmapData( 2, 2, true, 0x64f7a5e1 ),
				new BitmapData( 2, 2, true, 0x32ffffff )
			] );
			this.m_emitter = new Emitter( PointParticle, 100, -1, false );
			this.m_emitter.initParticles( bmd, 1.0, false );
			this.m_emitterRenderer.addEmitter( this.m_emitter );
		}
		
		/**
		 * Resets the emitters
		 */
		public function reset():void
		{
			this.m_emitter.reset();
		}
		
		public function emit( px:Number, py:Number ):void
		{
			this.m_emitter.emit( px, py );
		}
		
	}

}