package com.divillysausages.escvel.gui 
{
	import com.divillysausages.ds.core.IUpdateObj;
	import com.divillysausages.ds.DS;
	import com.divillysausages.escvel.assets.Resources;
	import com.divillysausages.escvel.constants.Trade;
	import com.divillysausages.escvel.logic.PlayerShip;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class SpeedBonus extends TextField implements IUpdateObj
	{
		private static const TF:TextFormat = new TextFormat( Resources.GAME_FONT, 15.0, 0xffffff, null, null, null, null, null, "center" );
		
		private var m_player:PlayerShip	= null;
		private var m_bonus:Number 		= 0.0;
		private var m_speed:Number 		= 60.0;
		
		public function get active():Boolean { return true; }
		
		public function set player( p:PlayerShip ):void
		{
			this.m_player = p;
			this.m_player.signalCargo.add( this._onCargoChange );
			this._onCargoChange( null, 0, 0 );
		}
		
		public function SpeedBonus() 
		{
			this.defaultTextFormat 	= SpeedBonus.TF;
			this.embedFonts			= true;
			this.y					= 10.0;
			this.selectable			= false;
			this.mouseEnabled		= false;
			this.mouseWheelEnabled	= false;
			this.text				= " ";
			this.width				= 200.0;
			this.height				= this.textHeight + 4.0;
			DS.stage.addChild( this );
			
			this.alpha = 0.0;
			
			DS.addToUpdate( this );
		}
		
		public function update( dt:Number ):void
		{
			if ( this.m_bonus <= 0 )
			{
				if ( this.alpha > 0.0 )
					this.alpha -= 2.0 * dt;
				return;
			}
			
			if ( this.alpha < 1.0 )
				this.alpha += 2.0 * dt;
				
			this.m_bonus 	-= this.m_speed * dt;
			if ( this.m_bonus < 0.0 )
				this.m_bonus = 0.0;
			this.text 		= "BONUS: " + int( this.m_bonus );
			this.x			= DS.stage.stageWidth * 0.5 - this.width * 0.5;
		}
		
		private function _onCargoChange( cargo:Trade, amount:int, max:int ):void
		{
			if ( cargo != null )
			{
				// give the player the bonus
				if ( this.m_bonus > 1.0 )
					this.m_player.giveCredits( int( this.m_bonus ) );
					
				this.text 		= "BONUS: 0";
				this.x			= DS.stage.stageWidth * 0.5 - this.width * 0.5;
				this.m_bonus	= 0.0;
			}
			else
				this.m_bonus = 100.0 + 100.0 * Math.random();
		}
		
	}

}