package com.divillysausages.escvel.gui 
{
	import com.divillysausages.escvel.assets.Resources;
	import com.divillysausages.escvel.constants.Trade;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class TradeButton extends Button
	{
		private static const TF:TextFormat = new TextFormat( Resources.GAME_FONT, 10.0, null, null, null, null, null, null, "center" );
		
		public var label:TextField 	= null;
		public var price:int		= 0;
		
		private var m_trade:Trade = null;
		
		public function get trade():Trade { return this.m_trade; }
		
		public function TradeButton() 
		{
			super();
			this.width	= 100.0;
			this.height = 60.0;
			
			this.label 						= new TextField;
			this.label.autoSize				= TextFieldAutoSize.LEFT;
			this.label.defaultTextFormat	= TradeButton.TF;
			this.label.selectable			= false;
			this.label.mouseEnabled			= false;
			this.label.mouseWheelEnabled	= false;
			this.label.embedFonts			= true;
			this.addChild( this.label );
		}
		
		public function setTrade( t:Trade, price:int ):void
		{
			this.m_trade 	= t;
			this.price		= price;
			this.label.text = Trade.toButtonString( this.m_trade ).toUpperCase() + "\n" + price + " credits";
			this.label.x	= this.width * 0.5 - this.label.width * 0.5;
			this.label.y	= this.height * 0.5 - this.label.height * 0.5 - 3; // magic
		}
		
	}

}