package com.divillysausages.escvel.gui 
{
	import com.divillysausages.ds.math.MathHelper;
	import flash.display.DisplayObjectContainer;
	import flash.geom.Point;
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class Trail 
	{
		private var m_trail:Vector.<TrailPart>	= null;
		private var m_dir:Point					= null;
		private var m_prevX:Number				= 0.0;
		private var m_prevY:Number				= 0.0;
		
		public function Trail( parent:DisplayObjectContainer, index:int ) 
		{
			var len:int		= 100;
			this.m_trail 	= new Vector.<TrailPart>( len, false );
			for ( var i:int = 0; i < len; i++ )
			{
				var tp:TrailPart 	= new TrailPart;
				this.m_trail[i]		= tp;
				parent.addChildAt( tp, index );
			}
			
			this.m_dir = new Point;
		}
		
		private var m_prevRot:Number = 0.0;
		public function update( x:Number, y:Number, rotation:Number ):void
		{
			// get the dir from the prev pos to this one
			this.m_dir.x 	= this.m_prevX - x;
			this.m_dir.y 	= this.m_prevY - y;
			this.m_prevX	= x;
			this.m_prevY	= y;
			this.m_dir.normalize( 1.0 );
			
			// set the first x trail parts
			var start:int = 10;
			for ( i = start - 1; i >= 0; i-- )
			{
				var tp:TrailPart 	= this.m_trail.shift();
				tp.x 				= x + this.m_dir.x * i;
				tp.y 				= y + this.m_dir.y * i;
				tp.rotation 		= rotation;
				this.m_trail.push( tp );
			}
			this.m_prevRot = rotation;
			
			// update the alpha
			var len:int			= this.m_trail.length;
			var toRemove:Number	= 1.0 / ( len + 1 );
			var alpha:Number	= 1.0;
			for ( var i:int = len - 1; i >= 0; i-- )
			{
				this.m_trail[i].alpha	= alpha;
				alpha					-= toRemove;
			}
		}
		
	}

}
import com.divillysausages.ds.DS;
import com.divillysausages.escvel.assets.Resources;
import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.Sprite;

internal class TrailPart extends Sprite
{
	private static const bmd:BitmapData = DS.getAsset( Resources.RAINBOW_IMAGE ).bitmapData;
	
	public var bitmap:Bitmap = null;
	
	public function TrailPart()
	{
		this.bitmap 	= new Bitmap( TrailPart.bmd );
		this.bitmap.x	= -this.bitmap.width * 0.5;
		this.bitmap.y	= -this.bitmap.height * 0.5;
		this.addChild( this.bitmap );
	}
}