package com.divillysausages.escvel.logic 
{
	import com.divillysausages.ds.collections.objectpool.IPoolObj;
	import com.divillysausages.ds.core.IUpdateObj;
	import com.divillysausages.ds.DS;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.geom.Matrix;
	import flash.geom.Point;
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class Bullet extends Bitmap implements IUpdateObj, IPoolObj
	{
		private static var m_bmd:BitmapData = null;
		
		private var m_speed:Number 	= 350.0;
		private var m_dir:Point		= null;
		
		public function get active():Boolean { return this.visible; }
		
		public function Bullet() 
		{
			if ( Bullet.m_bmd == null )
			{
				var s:Shape = new Shape;
				s.graphics.beginFill( 0xff0000 );
				s.graphics.drawCircle( 0.0, 0.0, 2.0 );
				s.graphics.endFill();
				
				Bullet.m_bmd = new BitmapData( s.width, s.height, true, 0x00000000 );
				var m:Matrix = new Matrix;
				m.translate( s.width * 0.5, s.height * 0.5 );
				Bullet.m_bmd.draw( s, m );
			}
			
			this.bitmapData	= Bullet.m_bmd;
			this.m_dir		= new Point;
			this.visible 	= false;
			
			DS.addToUpdate( this );
		}
		
		public function setDir( x:Number, y:Number ):void
		{
			this.m_dir.x = x;
			this.m_dir.y = y;
		}
		
		public function setPos( x:Number, y:Number ):void
		{
			this.x = x - this.width * 0.5;
			this.y = y - this.height * 0.5;
		}
		
		public function init( params:* = null ):void 
		{
			this.visible = true;
		}
		
		public function update( dt:Number ):void
		{
			this.x += this.m_dir.x * this.m_speed * dt;
			this.y += this.m_dir.y * this.m_speed * dt;
			
			// if we're out of bounds, just return
			if ( this.x < -3000.0 || this.x > 3000.0 || this.y < -3000.0 || this.y > 3000.0 )
				ObjectPools.returnBullet( this );
		}
		
		public function reset():void 
		{
			this.visible = false;
		}
		
		public function destroy():void 
		{
			if ( this.parent != null )
				this.parent.removeChild( this );
		}
		
	}

}