package com.divillysausages.escvel.state
{
	import com.divillysausages.ds.core.GameState;
	import com.divillysausages.ds.DS;
	import com.divillysausages.escvel.assets.Resources;
	
	/**
	 * The init state that creates everything
	 * @author Damian Connolly
	 */
	public class StateInit extends GameState 
	{
		
		/*******************************************************************************************/
		
		private var m_main:Main 		= null;	// a reference to the main class
		private var m_inited:Boolean	= false;// have we inited the game
		
		/*******************************************************************************************/
		
		/**
		 * Creates the init state
		 * @param m		The init state
		 * @param name	The name of the state
		 */
		public function StateInit( m:Main, name:String ) 
		{
			this.m_main = m;
			super(name);
			
			// create the resources that we'll use in the game
			new Resources;
		}
		
		/**
		 * Inits our game
		 */
		override public function begin():void 
		{
			if ( this.m_inited )
			{
				DS.error( this, "We've already inited the game" );
				Game.instance.changeState( Game.STATE_MAIN_MENU );
				return;
			}
			
			// we've initied
			this.m_inited = true;
			
			// go to our check state
			Game.instance.changeState( Game.STATE_CHECK );
			//Game.instance.changeState( Game.STATE_PLAY );
		}
		
	}

}